using FarPoint.Win.Spread;
using System.Data;

namespace RangeClear
{
    public partial class Form1 : Form
    {
        private FpSpread fp = new FpSpread() { Dock = DockStyle.Left, Width = 600 };
        private DataTable _dtSource1;
        private DataTable _dtSource2;

        public Form1()
        {
            InitializeComponent();
            CreateDataSource();
            fp.Sheets.Add(new SheetView() { });
        }

        public void CreateDataSource()
        {
            _dtSource1 = new DataTable("Table1");
            _dtSource1.Columns.Add("Expense Code", typeof(string));
            _dtSource1.Columns.Add("Units", typeof(int));
            _dtSource1.Columns.Add("Amount", typeof(double));

            DataRow dr = default(DataRow);
            dr = _dtSource1.NewRow();
            dr[0] = "E101";
            dr[1] = 7600;
            dr[2] = 1900d;
            _dtSource1.Rows.Add(dr);


            dr = _dtSource1.NewRow();
            dr[0] = "E102";
            dr[1] = 438;
            dr[2] = 438d;
            _dtSource1.Rows.Add(dr);

            dr = _dtSource1.NewRow();
            dr[0] = "E103";
            dr[1] = 1500;
            dr[2] = 1500d;
            _dtSource1.Rows.Add(dr);

            dr = _dtSource1.NewRow();
            dr[0] = "E104";
            dr[1] = 500;
            dr[2] = 500d;
            _dtSource1.Rows.Add(dr);

            dr = _dtSource1.NewRow();
            dr[0] = "E105";
            dr[1] = 600;
            dr[2] = 600d;
            _dtSource1.Rows.Add(dr);

            dr = _dtSource1.NewRow();
            dr[0] = "E107";
            dr[1] = 300;
            dr[2] = 300d;
            _dtSource1.Rows.Add(dr);

            dr = _dtSource1.NewRow();
            dr[0] = "E107";
            dr[1] = 750;
            dr[2] = 750d;
            _dtSource1.Rows.Add(dr);

            _dtSource2 = new DataTable("Table2");
            _dtSource2.Columns.Add("Expense Code", typeof(string));
            _dtSource2.Columns.Add("Units", typeof(int));
            _dtSource2.Columns.Add("Amount", typeof(double));

            dr = default(DataRow);
            dr = _dtSource2.NewRow();
            dr[0] = "E101";
            dr[1] = 7600;
            dr[2] = 1900d;
            _dtSource2.Rows.Add(dr);


            dr = _dtSource2.NewRow();
            dr[0] = "E102";
            dr[1] = 438;
            dr[2] = 438d;
            _dtSource2.Rows.Add(dr);

            dr = _dtSource2.NewRow();
            dr[0] = "E103";
            dr[1] = 1500;
            dr[2] = 1500d;
            _dtSource2.Rows.Add(dr);

            dr = _dtSource2.NewRow();
            dr[0] = "E104";
            dr[1] = 500;
            dr[2] = 500d;
            _dtSource2.Rows.Add(dr);

            dr = _dtSource2.NewRow();
            dr[0] = "E105";
            dr[1] = 600;
            dr[2] = 600d;
            _dtSource2.Rows.Add(dr);

            dr = _dtSource2.NewRow();
            dr[0] = "E107";
            dr[1] = 300;
            dr[2] = 300d;
            _dtSource2.Rows.Add(dr);

            dr = _dtSource2.NewRow();
            dr[0] = "E107";
            dr[1] = 750;
            dr[2] = 750d;
            _dtSource2.Rows.Add(dr);

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            SetDataSourceToSheet();
            tabControl1.SelectedIndexChanged += TabControl1_SelectedIndexChanged;

        }

        public void SetDataSourceToSheet()
        {
            if (tabControl1.SelectedIndex == 0)
            {
                tabPage1.Controls.Add(fp);
                fp.DataSource = _dtSource2;

            }
            else
            {
                tabPage2.Controls.Add(fp);
                fp.DataSource = _dtSource1;
            }
            fp.ActiveSheet.Columns[1].AllowAutoSort = true;
            fp.ActiveSheet.Columns[2].AllowAutoSort = true;
        }

        private void TabControl1_SelectedIndexChanged(object? sender, EventArgs e)
        {
            CreateDataSource();
            fp.ActiveSheet.ClearRange(0, 0, fp.ActiveSheet.RowCount, fp.ActiveSheet.ColumnCount, true);
            SetDataSourceToSheet();
        }

        private void sortBtn_Click(object sender, EventArgs e)
        {
            // sorting row index 1 to 4 based on column index 1
            fp.ActiveSheet.SortRows(1, 4, new SortInfo[] { new SortInfo(1, true) });
        }
    }
}